part of tecfy_core_client_package;

class DashboardController extends BaseController {
  List<DashboardItemBase> types;

  AnimationController controller;
  AnimationController counterAnimationController;
  Animation<double> sizeAnimation;
  static const double size = 800.0;
  double size1 = 0;
  double size2 = 0;
  double size3 = 0;
  double size4 = 0;


  DashboardController(State<StatefulWidget> state) : super(state) {
    getType();

    
    //if(LayoutService.disableAnimation(context)){
      controller = AnimationController(
          vsync: state as TickerProviderStateMixin,
          duration: Duration(milliseconds: 600));
      sizeAnimation = Tween<double>(begin: 1.0, end: 0.0).animate(
          CurvedAnimation(parent: controller, curve: Curves.fastOutSlowIn));

      controller.addListener(() {
        size1 = size * getValueForAnimcation(sizeAnimation.value, 0.3);
        size2 = size * 2 * getValueForAnimcation(sizeAnimation.value, 0.20);
        size3 = size * 4 * getValueForAnimcation(sizeAnimation.value, 0.10);
        size4 = size * 8 * sizeAnimation.value;
        setState();
      });
    // }
  }

  getValueForAnimcation(double value, double th) => (value < th) ? 0: value;
  setCountdownTimerController(){
    if(controller == null) return;
    counterAnimationController = AnimationController(vsync: state as TickerProviderStateMixin, duration: Duration(seconds: 60));
    counterAnimationController.forward(); //from: counterAnimationController.value == 0.0 ? 1.0: counterAnimationController.value
  }
  refreshAnimation() {
    if(controller == null) return;
    size1 = size;
    size2 = size * 2;
    size3 = size * 3;
    size4 = size * 4;
    controller.reset();
    controller.forward();
  }

  getType()async{
    var typesResult = await ApiService.httpGetDynamic('Dashboard/GetTypes');
    // print(typesResult.data);
    if(typesResult.success){
      types = typesResult.data.map<DashboardItemBase>((d)=>DashboardItemBase.fromMap(d)).toList();
      setState();
      refreshAnimation();
    }
  }

  Future<void> refreshData()async{

    types.forEach((t)=> t.value = null);
    types.forEach((t)=> getData(t));
    await Future.delayed(Duration(seconds: 1));
    refreshAnimation();
  }

  Future<dynamic> getData(DashboardItemBase type) async{
    if(type.value != null ) return type.value;
    if(type.value == -1) return null;
    type.value = -1;
    var result = await ApiService.httpGetDynamic('Dashboard/GetData/${type.dbName}');
    print(result.toString());
    // print(result.data);
    if(result.success){
      //return result.data;
      type.value =result.data;
    }else{
      type.value ='0';
    }
    setState();
    return type.value;
  }

}