part of tecfy_core_client_package;

class TecfyCoreApp extends StatelessWidget {
  static GlobalKey<NavigatorState> appGlobalkey = GlobalKey<NavigatorState>();
  static set apiURL(v)=> ConfigService.apiURL = v;
  static set wsURL(v)=> ConfigService.wsURL = v;
  // static String wsURL = '';
  static Map<String,IEntityTransaction> entityServices = Map<String,IEntityTransaction>();
  static IThemeConfig themeConfig;
  static Image logo ;
  static void Function(BuildContext) navigateToDefaultPage = (c)=> AppNavigator.navigateTo(c, () => DashboardPage(), replaceAll: true, animationType: AnimationTypes.opacity);
  static Future Function(Database,int,int) updateSqlLiteDb = (d,f,t)async{};
  static int appDbVersion =0;
  static IMenuInterface menuService;
  // This widget is the root of your application.
  @override
  Widget build(BuildContext context) {
    return MaterialApp(
      title: 'Application',
      navigatorKey: appGlobalkey,
      theme: ThemeService.getMainThemeAndroid(),
      home: SplashScreenPage(),
      supportedLocales: [const Locale('ar', 'SA'), const Locale('en', 'US')],
      localizationsDelegates: [
        const AppLocalizationsDelegate(),
        GlobalMaterialLocalizations.delegate,
        GlobalWidgetsLocalizations.delegate
      ],
      
      localeResolutionCallback:
          (Locale deviceLocale, Iterable<Locale> supportedLocales){        
          print('---------------------------------- Check Language ------------------------------------- ${LocalConfigService.language}');
          
          var selectedLanguageCode = LocalConfigService.isArabic ? 'ar' : 'en';        
          var lcl = supportedLocales.where((d)=>d.languageCode == selectedLanguageCode).first ?? supportedLocales.first;
          print('-------------------------------------------------- ' + lcl.languageCode);
          return lcl;
      },
    );
  }
}



class TecfyMainApplication extends StatefulWidget {
  
  static restartApp(BuildContext context) {
    final _TecfyMainApplicationState state = context.ancestorStateOfType(const TypeMatcher<_TecfyMainApplicationState>());
    state.restartApp();
  }

  @override
  _TecfyMainApplicationState createState() => new _TecfyMainApplicationState();
}

class _TecfyMainApplicationState extends State<TecfyMainApplication> {
  Key key = new UniqueKey();
  Widget child;

  void restartApp() {
    this.setState(() {
      key = new UniqueKey();
    });
  }

  @override
  void initState() {
    child=TecfyCoreApp();
    super.initState();
  }

  @override
  Widget build(BuildContext context) {
    return new Container(
      key: key,
      child: child,
    );
  }
}
