part of tecfy_core_client_package;

class AppLocale {
  AppLocale(this.locale);

  final Locale locale;
  static AppLocale appLocale;
  static AppLocale of(BuildContext context) {
    
    if(appLocale != null) return appLocale; 
    //print('+++++++++++++++ init');
    if (context == null) {
      print('+++++++++++++++ NULLLLLLLLLLLLLL');
      return new AppLocale(null);
    }
    var result = Localizations.of<AppLocale>(context, AppLocale);
    if(result == null) print('+++++++++++++++++ class is null');
    else appLocale = result;
    return result;
  }

  Map<String, dynamic> _sentences;

  Future<bool> load() async {
    //from file
    //String data = await rootBundle.loadString('resources/lang/${this.locale.languageCode}.json');
    //from databse
    print('================== Start Loading the language');
    // Firestore.instance.document('languages/${this.locale.languageCode}/translation/default').snapshots().listen((onData){
    //   this._sentences = onData.data;  
    await ConfigService.init();
    this._sentences = LocalConfigService.isArabic ? {
      'Main Page':'الشاشه الرئيسيه',
      'Reports':'التقارير',
      'Settings':'الاعدادات',
      'Logout':'تسجيل خروج',
      'Loading':'جاري التحميل',
      'Filter':'تصفيه',
      'OK':'موافق',
      'Add Row':'اضافه جديد',
      'Contain':'يحتوي',
      'Not Contain':'لا يحتوي',
      'Email or Username':'اسم المستخدم او البريد الاكتروني',
      'Password':'كلمه المرور',
      'LOG IN':'تسجيل دخول',
      'OR':'او',
      'Contact Us':'تواصل معنا',
      'Add':'اضافه',
      'Refresh':'تحديث',
      'Next Page':'التالي',
      'Language':'اللغه',
      'Please wait':'جاري التحميل',
      'Action':'الاجراء',
      'Filter':'تصفيه'
    } : {};
    // });
    //var language = await Firestore.instance.document('languages/ar').get();
    //print('================== got some data');
    //print(language.data);
    //print(language.data['Driver']);
    //this._sentences = language.data;
    return true;

    // var language = await Firestore.instance.document('languages/default').get();
    // String data = language.data[this.locale.languageCode].toString();

    // this._sentences = json.decode(data);
    // return true;
  }

  static String translate(BuildContext context,String key){
    if(context == null || key == null) return key ?? '[NULL]';

    var cls = of(context);
    if(cls == null)return key ?? '[NULL]';

    return cls.trans(key) ?? key;
  }

  String trans(String key) {
    //print('+++++++++++++++ get lang $key');
    if (key == null) return '';
    try {
      if (this._sentences == null) { print('_sentences is null'); return key;}
      return this._sentences.containsKey(key) ? this._sentences[key] : key;
    } catch (ex) {
      print(ex.toString());
      return key; 
    }
  }
}
