part of tecfy_core_client_package;

class LoginPage extends StatefulWidget {
  @override
  _LoginPageState createState() => _LoginPageState();
}

class _LoginPageState extends State<LoginPage> {
  LoginController _controller;
  @override
  void initState() {
    _controller = LoginController(this);
    super.initState();
  }
  @override
  void dispose() {
    _controller.dispose();
    super.dispose();
  }
  @override
  Widget build(BuildContext context) {
    return Scaffold(
      //resizeToAvoidBottomPadding :false,
      body:LayoutService.bindWidget(context, mobileWidget: getMobileWidget(), descktopWidget:getDesctopWidget())
    );
  }

  Widget getDesctopWidget(){
    return  Row(
        children: <Widget>[
          Container(
             width: 300,
              color: ThemeService.mainColor,
              child: TecfyCoreApp.logo == null ? Container(): Center(child: Image(image: TecfyCoreApp.logo.image, height :150.0, width: 200.0))
              ),
          Expanded(
              child: Center(child: Container(
                  constraints: BoxConstraints(minWidth: 100, maxWidth: 500),
                  padding: EdgeInsets.symmetric(horizontal: 30.0),
                  child: getLoginForm())))
        ],
      );
  }

  Widget getMobileWidget(){
    return  Column(
        children: <Widget>[
          Container(
              height:
                  MediaQuery.of(context).viewInsets.bottom == 0 ? 250.0 : 120.0,
              color: ThemeService.mainColor,
              child: TecfyCoreApp.logo == null ? Container(): Center(child: Image(image: TecfyCoreApp.logo.image, height :150.0, width: 200.0))
              ),
          Expanded(
              child: Container(
                  constraints: BoxConstraints(minWidth: 100, maxWidth: 500),
                  padding: EdgeInsets.symmetric(horizontal: 30.0),
                  child: getLoginForm()))
        ],
      );
  }

  Widget getLoginForm(){
    return Form(
        key: _controller.formKey,
        child: SingleChildScrollView(
                child: Column(
              children: <Widget>[
                SizedBox(height: 50.0),
                AppTextFormField(
                    labelText:AppLocale.translate(context, 'Email or Username'),
                    controller: _controller.usernameController,
                    validator: _controller.usernameValidator,
                    keyboardType: TextInputType.emailAddress),
                AppTextFormField(
                    labelText: AppLocale.translate(context, 'Password'),
                    controller: _controller.passwordController,
                    validator: _controller.passwordValidator,
                    obscureText: true),
                SizedBox(height: 50.0),
                AppButtonPost(
                    label: AppLocale.translate(context, 'LOG IN'),
                    onPressed: _controller.onLogin),
                SizedBox(height: 20.0),
                Row(
                  children: <Widget>[
                    Expanded(child: Divider()),
                    Padding(padding:EdgeInsets.symmetric(horizontal: 10.0),child: Text(AppLocale.translate(context, 'OR'),style: TextStyle(fontSize: 11.0))),
                    Expanded(child: Divider()),
                  ],
                ),
                SizedBox(height: 20.0),
                
                FlatButton(child: Text(AppLocale.translate(context, 'Contact Us'),style: TextStyle(color: ThemeService.mainColor)),onPressed: _controller.contactUs),
                StreamBuilder(stream:ConnectionService.activeConnectionStream,builder: (c,_)=> ConnectionService.getConnectionIcon(c) )
                ],
            )),
      );
  }
}