part of tecfy_core_client_package;

class BasePage extends Scaffold {

  final String title;
  final List<Widget> appBarActions;
  final Widget appBarBottom;
  final Widget child;
  final FloatingActionButton floatingActionButtonWidget;

  BasePage(BuildContext context,this.title,{this.appBarActions,this.appBarBottom,this.child, this.floatingActionButtonWidget}) : 
        super(
          appBar:LayoutService.isMobile(context) ? _getAppBar(context,title,appBarActions,appBarBottom) : null, 
          drawer: !Navigator.of(context).canPop() && LayoutService.isMobile(context) ? MainDrawer(title) : null,
          floatingActionButton:  LayoutService.isMobile(context) ?  floatingActionButtonWidget : null,
          body: LayoutService.isMobile(context) ? child :
            Row(
                mainAxisAlignment: MainAxisAlignment.start,
                crossAxisAlignment: CrossAxisAlignment.start,
                children: <Widget>[
                  Container(child: MainDrawer(title),width: 200),
                  Expanded(child:                   
                  Column(children: <Widget>[
                    Container(width: MediaQuery.of(context).size.width - 200, height: 100, child: _getAppBar(context,title,appBarActions,appBarBottom)),
                    Expanded(child: Align(alignment: Alignment.topCenter,child: child))
                    ])
                  )
                ],
              )
          );
 
  static AppBar _getAppBar(BuildContext context,String title,List<Widget> appBarActions,Widget bottom){
    return MainAppBar(
          context: context,
          title: AppLocale.translate(context, title ?? '') ,
          actions: LayoutService.isMobile(context) || bottom != null ? appBarActions : null, 
          bottom: bottom ?? getActionsAsBottom(context,appBarActions));
  }
    
  static PreferredSize getActionsAsBottom(context,appBarActions) {
    if(LayoutService.isMobile(context))return null;
    return PreferredSize( 
      preferredSize: Size(100,100) ,
      child: Row(children:appBarActions, mainAxisAlignment: MainAxisAlignment.end,)
    );
    // return PreferredSize( 
    //   preferredSize: Size(LayoutService.getWidth(context),100) ,
    //   child: Align(alignment: Alignment.centerRight,child:Row(children:appBarActions, mainAxisAlignment: MainAxisAlignment.end,))
    // );
  }

}
