part of tecfy_core_client_package;

class EntityFormPage extends StatefulWidget {
  final String entity;
  final dynamic data;
  EntityFormPage(this.entity, [this.data]);
  @override
  _EntityFormPageState createState() => _EntityFormPageState();
}

class _EntityFormPageState extends State<EntityFormPage> {
  EntityFormController _controller;

  @override
  void initState() {
    _controller = EntityFormController(this, widget.entity, widget.data);
    super.initState();
  }

  

  @override
  Widget build(BuildContext context) {
    
    return DefaultTabController(
        length: _controller.tabs.keys.length,
        child: BasePage(context,_controller.entity.name,    
              appBarActions: !_controller.canSave ? [] : <Widget>[IconButton(icon: Icon(Icons.save,color: Colors.white), onPressed: _controller.onSave)],
              appBarBottom: _controller.tabs.length > 1 ? TabBar(tabs: _controller.tabs.keys.map((tab) => Tab(child: Text(tab ?? ''))).toList()): null,
        child:
          Align(alignment: Alignment.center,child: Container(
        constraints: BoxConstraints(maxWidth: ThemeService.containerWidth),
        child:
           _controller.tabs.length > 1? TabBarView(children: _controller.tabs.keys.map<Widget>((tab) => getData(_controller.tabs[tab])).toList()): getData(_controller.properties),
          ))
        ));
  }

  getData(List<Property> props) {
    
    return props.length == 1
        ? ListView(children:<Widget>[ PorpertyComponent(
            readOnly: !_controller.canSave,
            property: props.first,
            entity:_controller.entity,
            //filterValue: _controller.data[props.first.filterValueField],
            data:_controller.data,
            onChange: (v) => _controller.onValueChanged(v,props.first.dbName),//_controller.data[props.first.dbName] = v,
            )])
        : ListView(
            padding: EdgeInsets.symmetric(horizontal: 20),
            children: props
                .map<Widget>((p) => PorpertyComponent(
                    readOnly: !_controller.canSave,
                    property: p,
                    entity: _controller.entity,
                    // onChange: (v) => _controller.data[p.dbName] = v,
                    //filterValue: _controller.data[p.filterValueField],
                    data:_controller.data,
                    onChange: (v) => _controller.onValueChanged(v,p.dbName),
                  ))
                .toList());
  }
}
