part of tecfy_core_client_package;

class DashboardPage extends StatefulWidget {
  @override
  _DashboardPageState createState() => _DashboardPageState();
}

class _DashboardPageState extends State<DashboardPage> with TickerProviderStateMixin {
  DashboardController _controller;
  @override
  void initState() {
    super.initState();
    _controller = DashboardController(this); 
  }

  onItemTab(type)async{
        if(type.onClick == null || type.onClick.isEmpty)return;
        if(type.onClick.startsWith('EntityList:')){
          AppNavigator.navigateTo(context, ()=>EntityListPage(type.onClick.replaceAll('EntityList:', '')));
          return;
        }
        if(type.onClick.startsWith('Report:')){
          var result = await ApiService.httpGetDynamic('Report/GetList');          
          var reportName = type.onClick.replaceAll('Report:', '');
          AppNavigator.navigateTo(context, ()=>ReportDetailPage(result.data.firstWhere((s)=>s['dbName'] ==reportName),[]));
          return;
        }
      }

  @override
  Widget build(BuildContext context) {
    return BasePage(context,'Main Page',
      appBarActions: <Widget>[
        NotificationIcon(),
        IconButton(onPressed: ()=>AppNavigator.navigateTo(context, ()=>ChatContactsPage()),icon: Icon(Icons.message,color: Colors.white))
      ],
      child: _controller.types == null ? Center(child: CircularProgressIndicator(valueColor:AlwaysStoppedAnimation<Color>(ThemeService.mainColor)))  : 
      RefreshIndicator(
        onRefresh: _controller.refreshData,
        child: Wrap(
          alignment: WrapAlignment.center,
          runAlignment: WrapAlignment.center,
          crossAxisAlignment: WrapCrossAlignment.start,
        children: _controller.types.map((type){
          switch(type.type){
            case "Statistic":
              return getStatistic(type);     
            default:
            return Container();
          }
        }).toList()
        ..insert(0, SizedBox(height:_controller.size1))
            ..insert(_controller.types.length > 1 ? 2 : 1, SizedBox(height:_controller.types.length > 1 ? _controller.size2 : 0))
            ..insert(_controller.types.length > 2 ? 4 : 1, SizedBox(height: _controller.types.length > 2 ? _controller.size3 : 0))
            ..insert(_controller.types.length > 3 ? 6 : 1, SizedBox(height:_controller.types.length > 3 ? _controller.size4 : 0))
      )
      )
    );
  }

  Widget getStatistic(DashboardItemBase type){
    
    return Container(
      constraints: BoxConstraints(minWidth: 500),
      child:  GestureDetector(
      onTap: ()=>onItemTab(type),
      child: Card(
      elevation: 2,
      margin: EdgeInsets.all(10),
      child: Column(children: <Widget>[
        SizedBox(height:10),
        Text(type.title ?? ''),
        SizedBox(height:10),
        FutureBuilder<dynamic>(
          future: _controller.getData(type),
          builder:(c,snap)=> Text(type.value != null ? type.value.toString().trim().replaceAll('SAR', LocalConfigService.isArabic ? 'ريال' : 'SAR'  ) ?? '-' : '${AppLocale.translate(c,'Loading')}..'),
        ),
        SizedBox(height:10),
      ],) 

    )));
  }
}